!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_visi2image_template
  use cubecompute_messaging
  use cubecompute_one2one_template
  !
  public :: visi2image_comm_t,visi2image_prog_t
  private
  !
  type, extends(one2one_comm_t) :: visi2image_comm_t
  end type visi2image_comm_t
  !
  type, extends(one2one_prog_t) :: visi2image_prog_t
   contains
     procedure, public  :: header => cubecompute_visi2image_prog_header
     procedure, private :: loop   => cubecompute_visi2image_prog_loop
     procedure, private :: act    => cubecompute_visi2image_prog_act
  end type visi2image_prog_t
  !
contains
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_visi2image_prog_header(prog,error)
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(visi2image_prog_t), intent(inout) :: prog
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='VISI2IMAGE>PROG>HEADER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call prog%one2one_prog_t%header(error)
    if (error) return
    call cubetools_header_make_array_real(prog%oucube%head,error)
    if (error) return
  end subroutine cubecompute_visi2image_prog_header
  !
  subroutine cubecompute_visi2image_prog_loop(prog,first,last,error)
    use cubetools_parameters
    use cubeadm_entryloop
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(visi2image_prog_t), intent(inout) :: prog
    integer(kind=entr_k),     intent(in)    :: first
    integer(kind=entr_k),     intent(in)    :: last    
    logical,                  intent(inout) :: error
    !
    integer(kind=entr_k) :: ie
    type(visi_t) :: visi
    type(image_t) :: image
    character(len=*), parameter :: rname='VISI2IMAGE>PROG>HEADER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call visi%associate('visi',prog%incube,error)
    if (error) return
    call image%allocate('image',prog%oucube,error)
    if (error) return
    !
    do ie=first,last
      call cubeadm_entryloop_iterate(ie,error)
      if (error) return
      call prog%act(ie,visi,image,error)
      if (error) return
    enddo ! ie
  end subroutine cubecompute_visi2image_prog_loop
  !
  subroutine cubecompute_visi2image_prog_act(prog,ie,visi,image,error)
    use cubetools_parameters
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(visi2image_prog_t), intent(inout) :: prog
    integer(kind=entr_k),     intent(in)    :: ie
    type(visi_t),             intent(inout) :: visi
    type(image_t),            intent(inout) :: image
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='VISI2IMAGE>PROG>ACT'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
  end subroutine cubecompute_visi2image_prog_act
end module cubecompute_visi2image_template
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
